let Rslider;
let rslider;
let dslider;
function setup() {
  createCanvas(400, 400);
  background(0);
  Rslider = createSlider(0, 30, 5);
  Rslider.position(20, 20);
  rslider = createSlider(-15, 15, 3);
  rslider.position(220, 20);
  dslider = createSlider(0, 30, 5);
  dslider.position(20, 360);
}

const gcd = (a, b) => b == 0 ? a : gcd (b, a % b)
const lcm = (a, b) =>  a / gcd (a, b) * b
function hypoX(R, r, d, theta) {
  if (R == r) { return d * cos(theta); }
  return (R - r) * cos(theta) + d * cos((R - r) / r * theta);
}
function hypoY(R, r, d, theta) {
  if (R == r) { return d * sin(theta); }
  return (R - r) * sin(theta) - d * sin((R - r) / r * theta);
}

function scale_and_draw(R, r, d, rot) {
  let extent = TWO_PI * lcm(r, R) / R;
  let k = (width / 2 - 10) / (R - r + d);
  if (r > R) {
    k = (width / 2 - 10) / (r - R + d);
  }
  R *= k; r *= k; d *= k;
  
  noFill();
  beginShape();
  for(let i = 0; i < 1000; i++) {
    let x = hypoX(R, r, d, extent / 1000 * i);
    let y = hypoY(R, r, d, extent / 1000 * i);
    let acc_factor = mag(x, y);
    let wobble_dir = TWO_PI - TWO_PI * noise(5 * rot, x / 200, y / 200);
    let x_temp = x * cos(rot) - y * sin(rot) + 5 * cos(wobble_dir);
    y = x * sin(rot) + y * cos(rot) + 5 * sin(wobble_dir);
    x = x_temp;
    
    vertex(x + width / 2, y + height / 2);
  }
  endShape(CLOSE);
}

let rotation = 0;
let smooth_vel = 0.001;
function draw() {
  let R = Rslider.value();
  let r = rslider.value();
  if (r == 0) { r = 1/2; }
  let d = dslider.value();
  background(0, 100);
  strokeWeight(2);
  stroke(255);
  let vel = mag(movedX / width, movedY / height);
  vel *= vel * 3;
  vel += 0.001;
  smooth_vel = 0.9 * smooth_vel + 0.1 * vel;
  scale_and_draw(R, r, d, rotation, smooth_vel);
  rotation += smooth_vel;
}
